## ardour3 3.5.403~dfsg

=== wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import string
import subprocess
import sys

def fetch_git_revision ():
    cmd = "git describe HEAD"
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    rev = output[0].decode ('utf-8')
    return rev

def fetch_tarball_revision ():
    if not os.path.exists ('libs/ardour/revision.cc'):
        print 'This tarball was not created correctly - it is missing libs/ardour/revision.cc'
        sys.exit (1)
    with open('libs/ardour/revision.cc') as f:
        content = f.readlines()
        remove_punctuation_map = dict((ord(char), None) for char in '";')
        return content[1].decode('utf-8').strip().split(' ')[7].translate (remove_punctuation_map)

if os.path.isdir (os.path.join(os.getcwd(), '.git')):
    rev = fetch_git_revision ()
else:
    rev = fetch_tarball_revision ()

#
# rev is now of the form MAJOR.MINOR-rev-commit
#

parts = rev.split ('.')
MAJOR = parts[0]
other = parts[1].split ('-')
MINOR = other[0]
MICRO = other[1]

V = MAJOR + '.' + MINOR + '.' + MICRO
#
# it is important that VERSION *not* be unicode string
# because if it is, it breaks waf somehow.
#
VERSION = V.encode ('ascii', 'ignore')
APPNAME = 'Ardour' + MAJOR

# Mandatory variables
top = '.'
out = 'build'

children = [
        'libs/pbd',
        'libs/midi++2',
        'libs/evoral',
        'libs/vamp-sdk',
        'libs/qm-dsp',
        'libs/vamp-plugins',
        'libs/taglib',
        'libs/libltc',
        'libs/rubberband',
        'libs/surfaces',
        'libs/panners',
        'libs/backends',
        'libs/timecode',
        'libs/ardour',
        'libs/gtkmm2ext',
        'libs/clearlooks-newer',
        'libs/audiographer',
        'libs/plugins/reasonablesynth.lv2',
        'gtk2_ardour',
        'export',
        'midi_maps',
        'mcp',
        'patchfiles'
]

i18n_children = [
        'gtk2_ardour',
        'libs/ardour',
        'libs/gtkmm2ext',
]

if sys.platform == 'linux2':
    children += [ 'tools/sanity_check' ]
    lxvst_default = True
elif sys.platform == 'darwin':
    children += [ 'libs/appleutility' ]
    lxvst_default = False
else:
    lxvst_default = False

# Version stuff

def fetch_gcc_version (CC):
    cmd = "LANG= %s --version" % CC
    output = subprocess.Popen(cmd, shell=True, stderr=subprocess.STDOUT, stdout=subprocess.PIPE).communicate()[0].splitlines()
    o = output[0].decode('utf-8')
    version = o.split(' ')[2].split('.')
    return version

def create_stored_revision():
    rev = ""
    if os.path.exists('.git'):
        rev = fetch_git_revision();
        print("Git version: " + rev + "\n")
    elif os.path.exists('libs/ardour/revision.cc'):
        print("Using packaged revision")
        return
    else:
        print("Missing libs/ardour/revision.cc.  Blame the packager.")
        sys.exit(-1)

    try:
        #
        # if you change the format of this, be sure to fix fetch_tarball_revision() above
        # so that  it still works.
        #
        text =  '#include "ardour/revision.h"\n'
        text += 'namespace ARDOUR { const char* revision = \"%s\"; }\n' % rev
        print('Writing revision info to libs/ardour/revision.cc using ' + rev)
        o = open('libs/ardour/revision.cc', 'w')
        o.write(text)
        o.close()
    except IOError:
        print('Could not open libs/ardour/revision.cc for writing\n')
        sys.exit(-1)

def set_compiler_flags (conf,opt):
    #
    # Compiler flags and other system-dependent stuff
    #

    build_host_supports_sse = False

    # Flags necessary for building
    compiler_flags = []     # generic
    c_flags = []            # C-specific
    cxx_flags = []          # C++-specific
    linker_flags = []

    # Optimization flags (overridable)
    optimization_flags = []

    # Debugging flags
    debug_flags = []

    u = os.uname ()
    cpu = u[4]
    platform = u[0].lower()
    version = u[2]

    # waf adds -O0 -g itself. thanks waf!
    is_clang = conf.env['CXX'][0].endswith('clang++')
    
    if conf.options.cxx11:
        conf.check_cxx(cxxflags=["-std=c++11"])
        cxx_flags.append('-std=c++11')
        if platform == "darwin":
            cxx_flags.append('-stdlib=libc++')
            link_flags.append('-lc++')
            # Prevents visibility issues in standard headers
            conf.define("_DARWIN_C_SOURCE", 1)

    if conf.options.asan:
        conf.check_cxx(cxxflags=["-fsanitize=address", "-fno-omit-frame-pointer"], linkflags=["-fsanitize=address"])
        cxx_flags.append('-fsanitize=address')
        cxx_flags.append('-fno-omit-frame-pointer')
        linker_flags.append('-fsanitize=address')

    if is_clang and platform == "darwin":
        # Silence warnings about the non-existing osx clang compiler flags
        # -compatibility_version and -current_version.  These are Waf
        # generated and not needed with clang
        cxx_flags.append("-Qunused-arguments")
        
    if opt.gprofile:
        debug_flags = [ '-pg' ]

    # Autodetect
    if opt.dist_target == 'auto':
        if platform == 'darwin':
            # The [.] matches to the dot after the major version, "." would match any character
            if re.search ("^[0-7][.]", version) != None:
                conf.env['build_target'] = 'panther'
            elif re.search ("^8[.]", version) != None:
                conf.env['build_target'] = 'tiger'
            elif re.search ("^9[.]", version) != None:
                conf.env['build_target'] = 'leopard'
            elif re.search ("^10[.]", version) != None:
                conf.env['build_target'] = 'snowleopard'
            elif re.search ("^11[.]", version) != None:
                conf.env['build_target'] = 'lion'
            else:
                conf.env['build_target'] = 'mountainlion'
        else:
            match = re.search(
                    "(?P<cpu>i[0-6]86|x86_64|powerpc|ppc|ppc64|arm|s390x?)",
                    cpu)
            if (match):
                conf.env['build_target'] = match.group("cpu")
                if re.search("i[0-5]86", conf.env['build_target']):
                    conf.env['build_target'] = "i386"
            else:
                conf.env['build_target'] = 'none'
    else:
        conf.env['build_target'] = opt.dist_target

    if conf.env['build_target'] == 'snowleopard':
        #
        # stupid OS X 10.6 has a bug in math.h that prevents llrint and friends
        # from being visible.
        # 
        compiler_flags.append ('-U__STRICT_ANSI__')

    if cpu == 'powerpc' and conf.env['build_target'] != 'none':
        #
        # Apple/PowerPC optimization options
        #
        # -mcpu=7450 does not reliably work with gcc 3.*
        #
        if opt.dist_target == 'panther' or opt.dist_target == 'tiger':
            if platform == 'darwin':
                # optimization_flags.extend ([ "-mcpu=7450", "-faltivec"])
                # to support g3s but still have some optimization for above
                compiler_flags.extend ([ "-mcpu=G3", "-mtune=7450"])
            else:
                compiler_flags.extend ([ "-mcpu=7400", "-maltivec", "-mabi=altivec"])
        else:
            compiler_flags.extend([ "-mcpu=750", "-mmultiple" ])
        compiler_flags.extend (["-mhard-float", "-mpowerpc-gfxopt"])
        optimization_flags.extend (["-Os"])

    elif ((re.search ("i[0-9]86", cpu) != None) or (re.search ("x86_64", cpu) != None)) and conf.env['build_target'] != 'none':


        #
        # ARCH_X86 means anything in the x86 family from i386 to x86_64
        # the compile-time presence of the macro _LP64 is used to 
        # distingush 32 and 64 bit assembler
        #

        if (re.search ("(i[0-9]86|x86_64)", cpu) != None):
            compiler_flags.append ("-DARCH_X86")

        if platform == 'linux' :

            #
            # determine processor flags via /proc/cpuinfo
            #

            if conf.env['build_target'] != 'i386':

                flag_line = os.popen ("cat /proc/cpuinfo | grep '^flags'").read()[:-1]
                x86_flags = flag_line.split (": ")[1:][0].split ()

                if "mmx" in x86_flags:
                    compiler_flags.append ("-mmmx")
                if "sse" in x86_flags:
                    build_host_supports_sse = True
                if "3dnow" in x86_flags:
                    compiler_flags.append ("-m3dnow")

            if cpu == "i586":
                compiler_flags.append ("-march=i586")
            elif cpu == "i686":
                compiler_flags.append ("-march=i686")

        if not is_clang and ((conf.env['build_target'] == 'i686') or (conf.env['build_target'] == 'x86_64')) and build_host_supports_sse:
            compiler_flags.extend (["-msse", "-mfpmath=sse", "-DUSE_XMMINTRIN"])

    # end of processor-specific section

    # optimization section
    if conf.env['FPU_OPTIMIZATION']:
        if sys.platform == 'darwin':
            compiler_flags.append("-DBUILD_VECLIB_OPTIMIZATIONS");
            linker_flags.append("-framework Accelerate")
        elif conf.env['build_target'] == 'i686' or conf.env['build_target'] == 'x86_64':
            compiler_flags.append ("-DBUILD_SSE_OPTIMIZATIONS")
        if not build_host_supports_sse:
            print("\nWarning: you are building Ardour with SSE support even though your system does not support these instructions. (This may not be an error, especially if you are a package maintainer)")

    # end optimization section

    #
    # no VST on x86_64
    #

    if conf.env['build_target'] == 'x86_64' and opt.windows_vst:
        print("\n\n==================================================")
        print("You cannot use VST plugins with a 64 bit host. Please run waf with --windows-vst=0")
        print("\nIt is theoretically possible to build a 32 bit host on a 64 bit system.")
        print("However, this is tricky and not recommended for beginners.")
        sys.exit (-1)

    if opt.lxvst:
        if conf.env['build_target'] == 'x86_64':
            compiler_flags.append("-DLXVST_64BIT")
        else:
            compiler_flags.append("-DLXVST_32BIT")

    #
    # a single way to test if we're on OS X
    #

    if conf.env['build_target'] in ['panther', 'tiger', 'leopard', 'snowleopard' ]:
        conf.define ('IS_OSX', 1)
        # force tiger or later, to avoid issues on PPC which defaults
        # back to 10.1 if we don't tell it otherwise.

        compiler_flags.extend(
                ("-DMAC_OS_X_VERSION_MIN_REQUIRED=1040",
                 '-mmacosx-version-min=10.4'))

    elif conf.env['build_target'] in [ 'lion', 'mountainlion' ]:
        compiler_flags.extend(
                ("-DMAC_OS_X_VERSION_MIN_REQUIRED=1070",
                 '-mmacosx-version-min=10.7'))
    else:
        conf.define ('IS_OSX', 0)

    #
    # save off CPU element in an env
    #
    conf.define ('CONFIG_ARCH', cpu)

    #
    # ARCH="..." overrides all
    #

    if opt.arch != None:
        optimization_flags = opt.arch.split()

    #
    # prepend boiler plate optimization flags that work on all architectures
    #

    optimization_flags[:0] = ["-pipe"]

    # don't prepend optimization flags if "-O<something>" is present
    prepend_opt_flags = True
    for flag in optimization_flags:
        if flag.startswith("-O"):
            prepend_opt_flags = False
            break

    if prepend_opt_flags:
        optimization_flags[:0] = [
                "-O3",
                "-fomit-frame-pointer",
                "-ffast-math",
                "-fstrength-reduce"
                ]

    if opt.stl_debug:
        cxx_flags.append("-D_GLIBCXX_DEBUG")

    if conf.env['DEBUG_RT_ALLOC']:
        compiler_flags.append('-DDEBUG_RT_ALLOC')
        linker_flags.append('-ldl')

    if conf.env['DEBUG_DENORMAL_EXCEPTION']:
        compiler_flags.append('-DDEBUG_DENORMAL_EXCEPTION')

=== midi_maps/wscript ===
#!/usr/bin/python

import os

top = '.'
out = 'build'

def configure(conf):
    pass

def build(bld):
    maps = bld.path.ant_glob ('*.map')
    bld.install_files (os.path.join(bld.env['DATADIR'], 'ardour3', 'midi_maps'),
                       maps)

def options(opt):
    pass

=== templates/wscript ===
#!/usr/bin/python

#
# Paul notes (April 2013)
#
# There seems to be little point in including templates with Ardour
# until or as long as the input connections of tracks depends on
# the user's hardware configuration. This makes any pre-existing
# templates potentially wrong/useless/annoying for anyone who
# uses a different hardware input configuration than was used
# to create the templates. 
#
# Templates should be created by the user, not by us. 
#
# I modified the code below, but have not tested it. For now
# this directory will be removed from the top level wscript's
# list of children.
#

import os

top = '.'
out = 'build'

def configure(conf):
    pass

def build(bld):

    templates = bld.path.ant_glob('*/*.template')
    for t in templates:
        file_name = os.path.basename(t.srcpath())
        dir_name = os.path.dirname(t.srcpath())
        obj = bld(features = 'subst',
                  name = 'template',
                  source = [ t ],
                  target = [ os.path.join(dir_name, file_name) ],
                  install_path = os.path.join(bld.env['DATADIR'], 'ardour3', os.path.join('templates', dir_name)))

def options(opt):
    pass

=== libs/ardour/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os
import re
import subprocess
import sys

# default state file version for this build
CURRENT_SESSION_FILE_VERSION = 3001

# Variables for 'waf dist'
APPNAME = 'libardour3'
I18N_PACKAGE = 'ardour3'

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/ardour/'

libardour_sources = [
        'amp.cc',
        'analyser.cc',
        'async_midi_port.cc',
        'audio_buffer.cc',
        'audio_diskstream.cc',
        'audio_library.cc',
        'audio_playlist.cc',
        'audio_playlist_importer.cc',
        'audio_playlist_source.cc',
        'audio_port.cc',
        'audio_region_importer.cc',
        'audio_track.cc',
        'audio_track_importer.cc',
        'audioanalyser.cc',
        'audioengine.cc',
        'audiofile_tagger.cc',
        'audiofilesource.cc',
        'audioregion.cc',
        'audiosource.cc',
        'auditioner.cc',
        'automatable.cc',
        'automation.cc',
        'automation_control.cc',
        'automation_list.cc',
        'automation_watch.cc',
        'backend_search_path.cc',
        'beats_frames_converter.cc',
        'broadcast_info.cc',
        'buffer.cc',
        'buffer_manager.cc',
        'buffer_set.cc',
        'bundle.cc',
        'butler.cc',
        'capturing_processor.cc',
        'chan_count.cc',
        'chan_mapping.cc',
        'configuration.cc',
        'config_text.cc',
        'control_protocol_manager.cc',
        'control_protocol_search_path.cc',
        'cycle_timer.cc',
        'data_type.cc',
        'default_click.cc',
        'debug.cc',
        'delivery.cc',
        'directory_names.cc',
        'diskstream.cc',
        'element_import_handler.cc',
        'element_importer.cc',
        'engine_slave.cc',
        'enums.cc',
        'event_type_map.cc',
        'export_channel.cc',
        'export_channel_configuration.cc',
        'export_failed.cc',
        'export_filename.cc',
        'export_format_base.cc',
        'export_format_manager.cc',
        'export_format_specification.cc',
        'export_formats.cc',
        'export_formats_search_path.cc',
        'export_graph_builder.cc',
        'export_handler.cc',
        'export_preset.cc',
        'export_profile_manager.cc',
        'export_status.cc',
        'export_timespan.cc',
        'file_source.cc',
        'filename_extensions.cc',
        'filesystem_paths.cc',
        'filter.cc',
        'find_session.cc',
        'globals.cc',
        'graph.cc',
        'graphnode.cc',
        'iec1ppmdsp.cc',
        'iec2ppmdsp.cc',
        'import.cc',
        'instrument_info.cc',
        'internal_return.cc',
        'internal_send.cc',
        'interpolation.cc',
        'io.cc',
        'io_processor.cc',
        'kmeterdsp.cc',
        'ladspa_plugin.cc',
        'location.cc',
        'location_importer.cc',
        'ltc_slave.cc',
        'lv2_bundled_search_path.cc',
        'meter.cc',
        'midi_automation_list_binder.cc',
        'midi_buffer.cc',
        'midi_clock_slave.cc',
        'midi_diskstream.cc',
        'midi_model.cc',
        'midi_patch_manager.cc',
        'midi_patch_search_path.cc',
        'midi_playlist.cc',
        'midi_playlist_source.cc',
        'midi_port.cc',
        'midi_region.cc',
        'midi_ring_buffer.cc',
        'midi_source.cc',
        'midi_state_tracker.cc',
        'midi_stretch.cc',
        'midi_track.cc',
        'midi_ui.cc',
        'midiport_manager.cc',
        'mix.cc',
        'monitor_processor.cc',
        'mtc_slave.cc',
        'mtdm.cc',
        'mute_master.cc',
        'onset_detector.cc',
        'operations.cc',
        'pan_controllable.cc',
        'pannable.cc',
        'panner.cc',
        'panner_manager.cc',
        'panner_search_path.cc',
        'panner_shell.cc',
        'pcm_utils.cc',
        'pi_controller.cc',
        'playlist.cc',
        'playlist_factory.cc',
        'playlist_source.cc',
        'plugin.cc',
        'plugin_insert.cc',
        'plugin_manager.cc',
        'port.cc',
        'port_insert.cc',
        'port_manager.cc',
        'port_set.cc',
        'process_thread.cc',
        'processor.cc',
        'progress.cc',
        'quantize.cc',
        'rc_configuration.cc',
        'recent_sessions.cc',
        'region_factory.cc',
        'resampled_source.cc',
        'region.cc',
        'return.cc',
        'reverse.cc',
        'route.cc',
        'route_graph.cc',
        'route_group.cc',
        'route_group_member.cc',
        'rb_effect.cc',
        'send.cc',
        'session.cc',
        'session_butler.cc',
        'session_click.cc',
        'session_command.cc',
        'session_configuration.cc',
        'session_directory.cc',
        'session_events.cc',
        'session_export.cc',
        'session_handle.cc',
        'session_ltc.cc',
        'session_metadata.cc',
        'session_midi.cc',
        'session_object.cc',
        'session_playlists.cc',
        'session_process.cc',
        'session_rtevents.cc',
        'session_state.cc',
        'session_state_utils.cc',
        'session_time.cc',
        'session_transport.cc',
        'slave.cc',
        'smf_source.cc',
        'sndfile_helpers.cc',
        'sndfileimportable.cc',
        'sndfilesource.cc',
        'source.cc',
        'source_factory.cc',
        'speakers.cc',
        'srcfilesource.cc',
        'strip_silence.cc',
        'revision.cc',
        'tape_file_matcher.cc',
        'template_utils.cc',
        'tempo.cc',
        'tempo_map_importer.cc',
        'thread_buffers.cc',
        'ticker.cc',
        'track.cc',
        'transient_detector.cc',
        'unknown_processor.cc',
        'user_bundle.cc',
        'utils.cc',
        'version.cc',
        'vumeterdsp.cc',
        'worker.cc'
]

def flac_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.flac",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def ogg_supported():
    cmd = subprocess.Popen ("sndfile-info testfile.ogg",
                            stdout = subprocess.PIPE,
                            stderr = subprocess.STDOUT, shell = True)
    out = cmd.communicate()[0].decode('utf-8');
    return re.search ('unknown format', out) == None

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    conf.load('gas')
    # we don't use hard-coded micro versions with ardour, so hard code it to zero
    autowaf.build_version_files(
        path_prefix + 'ardour/version.h',
        path_prefix + 'version.cc',
        'libardour3', conf.env['MAJOR'], conf.env['MINOR'], 0)
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    autowaf.check_pkg(conf, 'libxml-2.0', uselib_store='XML')
    autowaf.check_pkg(conf, 'lrdf', uselib_store='LRDF',
                      atleast_version='0.4.0')
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE',
                      atleast_version='0.1.0')
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP',
                      atleast_version='2.0')

    if re.search ("linux", sys.platform) != None:
        autowaf.check_pkg(conf, 'alsa', uselib_store='ALSA')

    if Options.options.lv2:
        autowaf.check_pkg(conf, 'lv2', uselib_store='LV2',
                          atleast_version='1.0.0', mandatory=True)
        autowaf.check_pkg(conf, 'lv2', uselib_store='NEW_LV2',
                          atleast_version='1.0.15', mandatory=False)
        autowaf.check_pkg(conf, 'serd-0', uselib_store='SERD',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'sord-0', uselib_store='SORD',
                          atleast_version='0.8.0', mandatory=True)
        autowaf.check_pkg(conf, 'sratom-0', uselib_store='SRATOM',
                          atleast_version='0.2.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='LILV',
                          atleast_version='0.14.0', mandatory=True)
        autowaf.check_pkg(conf, 'lilv-0', uselib_store='NEW_LILV',
                          atleast_version='0.15.0', mandatory=False)
        autowaf.check_pkg(conf, 'suil-0', uselib_store='SUIL',
                          atleast_version='0.6.0', mandatory=False)
        conf.define ('LV2_SUPPORT', 1)

#    autowaf.check_pkg(conf, 'soundtouch-1.0', uselib_store='SOUNDTOUCH',
#                      mandatory=False)
    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT',
                      atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'ogg', uselib_store='OGG', atleast_version='1.1.2')
    autowaf.check_pkg(conf, 'flac', uselib_store='FLAC',
                      atleast_version='1.2.1')
    autowaf.check_pkg(conf, 'libcurl', uselib_store='CURL',
                      atleast_version='7.0.0')

    # we don't try to detect this, since its part of our source tree

    conf.define('HAVE_RUBBERBAND', 1) # controls whether we think we have it
    conf.define('USE_RUBBERBAND', 1)  # controls whether we actually use it

    conf.define('CURRENT_SESSION_FILE_VERSION', CURRENT_SESSION_FILE_VERSION)

    conf.check(header_name='sys/vfs.h', define_name='HAVE_SYS_VFS_H',mandatory=False)
    conf.check(header_name='sys/statvfs.h', define_name='HAVE_SYS_STATVFS_H',mandatory=False)

    conf.check(header_name='unistd.h', define_name='HAVE_UNISTD',mandatory=False)

    if flac_supported():
        conf.define ('HAVE_FLAC', 1)
    if ogg_supported():
        conf.define ('HAVE_OGG', 1)

    conf.write_config_header('libardour-config.h', remove=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/scoped_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/ptr_container/ptr_list.hpp')


def build(bld):
    # Library version (UNIX style major, minor, micro)
    # major increment <=> incompatible changes
    # minor increment <=> compatible changes (additions)
    # micro increment <=> no interface changes
    LIBARDOUR_LIB_VERSION = "3.0.0."

    # Library
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=libardour_sources)
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=libardour_sources)
        obj.cxxflags     = [ '-fPIC' ]
        obj.cflags       = [ '-fPIC' ]

    obj.export_includes = ['.']
    obj.includes     = ['.', '../surfaces/control_protocol', '..']
    obj.name         = 'ardour'
    obj.target       = 'ardour'
    obj.uselib       = ['GLIBMM','GTHREAD','AUBIO','SIGCPP','XML','UUID',
                        'SNDFILE','SAMPLERATE','LRDF','AUDIOUNITS',
                        'OSX','BOOST','CURL','DL']
    obj.use          = ['libpbd','libmidipp','libevoral','libvampplugin',
                        'libaudiographer','libltc','libtimecode']
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        obj.uselib.extend(['RUBBERBAND', 'TAGLIB', 'LIBLTC', 'VAMPSDK',
                           'VAMPHOSTSDK'])
    else:
        obj.use.extend(['libltc', 'librubberband', 'libtaglib', 'libvamphost'])

    obj.vnum         = LIBARDOUR_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.defines      = [
        'PACKAGE="' + I18N_PACKAGE + '"',
        'DATA_DIR="' + os.path.normpath(bld.env['DATADIR']) + '"',
        'CONFIG_DIR="' + os.path.normpath(bld.env['SYSCONFDIR']) + '"',

=== libs/audiographer/wscript ===
#!/usr/bin/env python
# -*- coding: utf-8 -*-
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
AUDIOGRAPHER_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
AUDIOGRAPHER_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'audiographer'
VERSION = AUDIOGRAPHER_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'sigc++-2.0', uselib_store='SIGCPP', atleast_version='2.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2', mandatory=False)
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0', mandatory=False)
    autowaf.check_pkg(conf, 'samplerate', uselib_store='SAMPLERATE', atleast_version='0.1.7', mandatory=False)
    autowaf.check_pkg(conf, 'sndfile', uselib_store='SNDFILE', atleast_version='1.0.18', mandatory=False)

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/format.hpp')

def build(bld):

    # Headers
    #bld.install_files('${INCLUDEDIR}/audiographer', bld.path.ant_glob('audiographer/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/general', bld.path.ant_glob('audiographer/general/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/sndfile', bld.path.ant_glob('audiographer/sndfile/*.h'))
    #bld.install_files('${INCLUDEDIR}/audiographer/utils', bld.path.ant_glob('audiographer/utils/*.h'))

    #bld.env['BUILD_TESTS'] = True
    bld.env['HAVE_ALL_GTHREAD'] = (bld.is_defined('HAVE_GLIB')
                                   and bld.is_defined('HAVE_GLIBMM')
                                   and bld.is_defined('HAVE_GTHREAD'))

    audiographer = bld(features = 'cxx cxxshlib')
    audiographer.source = '''
            private/gdither/gdither.cc
            src/general/sample_format_converter.cc
            src/routines.cc
            src/debug_utils.cc
            src/general/broadcast_info.cc
    '''

    if bld.is_defined('HAVE_SAMPLERATE'):
        audiographer.source += '''
                src/general/sr_converter.cc
        '''

    audiographer.name           = 'libaudiographer'
    audiographer.target         = 'audiographer'
    audiographer.export_includes = ['.', './src']
    audiographer.includes       = ['.', './src']
    audiographer.uselib         = 'GLIB GLIBMM GTHREAD SAMPLERATE SNDFILE'
    audiographer.use            = 'libpbd'
    audiographer.vnum           = AUDIOGRAPHER_LIB_VERSION
    audiographer.install_path   = os.path.join(bld.env['LIBDIR'], 'ardour3')


    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                tests/test_runner.cc
                tests/type_utils_test.cc
                tests/utils/identity_vertex_test.cc
                tests/general/interleaver_test.cc
                tests/general/deinterleaver_test.cc
                tests/general/interleaver_deinterleaver_test.cc
                tests/general/chunker_test.cc
                tests/general/sample_format_converter_test.cc
                tests/general/peak_reader_test.cc
                tests/general/normalizer_test.cc
                tests/general/silence_trimmer_test.cc
        '''

        if bld.is_defined('HAVE_ALL_GTHREAD'):
            obj.source += '''
                    tests/general/threader_test.cc
            '''

        if bld.is_defined('HAVE_SNDFILE'):
            obj.source += '''
                    tests/sndfile/tmp_file_test.cc
            '''

        if bld.is_defined('HAVE_SAMPLERATE'):
            obj.source += '''
                    tests/general/sr_converter_test.cc
            '''

        obj.use          = 'libaudiographer'
        obj.uselib       = 'CPPUNIT GLIBMM'
        obj.target       = 'run-tests'
        obj.install_path = ''

def shutdown():
    autowaf.shutdown()

=== libs/clearlooks-newer/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os
import sys

top = '.'
out = 'build'

path_prefix = 'libs/clearlooks-newer'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_c')
    autowaf.configure(conf)

def build(bld):
    obj = bld(features = 'c cshlib')
    obj.source = '''
    animation.c
    cairo-support.c
    clearlooks_draw.c
    clearlooks_draw_glossy.c
    clearlooks_draw_gummy.c
    clearlooks_draw_inverted.c
    clearlooks_rc_style.c
    clearlooks_style.c
    clearlooks_theme_main.c
    support.c
    widget-information.c
    '''

    obj.name = 'clearlooks-newer'
    obj.target = 'clearlooks'
    obj.uselib = 'GTK'
    obj.includes = '.'
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3', 'engines')

    if sys.platform == 'darwin':
        # Bit of a hack: make a symlink to the .dylib that meets GTK's criteria for finding it (namely that the library must be a *.so
        # and that it must reside in a directory called `engines')
        obj = bld(target = 'engines', rule = 'mkdir -p ${TGT} && rm -f ${TGT}/libclearlooks.so && ln -s ../libclearlooks.dylib ${TGT}/libclearlooks.so')
    else:
        # this is a hack so that running ./ardev will work, since it sets GTK_PATH to include this dir and GTK will search {thisdir}/engines
        obj = bld(target = 'engines', rule = 'mkdir -p ${TGT} && rm -f ${TGT}/libclearlooks.so && ln -s ../libclearlooks.so ${TGT}/libclearlooks.so')

def shutdown():
    autowaf.shutdown()

=== libs/evoral/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os

# Version of this package (even if built as a child)
EVORAL_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
# Version history:
#   0.0.0 = 0,0,0
EVORAL_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'evoral'
VERSION = EVORAL_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)
    opt.add_option('--test', action='store_true', default=False, dest='build_tests',
                    help="Build unit tests")
    opt.add_option('--test-coverage', action='store_true', default=False, dest='test_coverage',
                    help="Use gcov to test for code coverage")

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    #autowaf.display_header('Evoral Configuration')

    autowaf.check_pkg(conf, 'cppunit', uselib_store='CPPUNIT', atleast_version='1.12.0', mandatory=False)
    autowaf.check_pkg(conf, 'glib-2.0', uselib_store='GLIB', atleast_version='2.2')
    autowaf.check_pkg(conf, 'glibmm-2.4', uselib_store='GLIBMM', atleast_version='2.14.0')
    autowaf.check_pkg(conf, 'gthread-2.0', uselib_store='GTHREAD', atleast_version='2.14.0')

    # Boost headers
    autowaf.check_header(conf, 'cxx', 'boost/shared_ptr.hpp')
    autowaf.check_header(conf, 'cxx', 'boost/weak_ptr.hpp')

    conf.env['BUILD_TESTS'] = Options.options.build_tests
    conf.env['TEST_COVERAGE'] = Options.options.test_coverage

    #autowaf.display_msg(conf, "Unit tests", str(conf.env['BUILD_TESTS']))
    #print

def build(bld):
    # Headers
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.h')
    #bld.install_files('${INCLUDEDIR}/evoral', 'evoral/*.hpp')

    # Pkgconfig file
    #autowaf.build_pc(bld, 'EVORAL', EVORAL_VERSION, 'GLIBMM GTHREAD')

    libsmf = bld(features = 'c cshlib')
    libsmf.source = '''
            src/libsmf/smf.c
            src/libsmf/smf_decode.c
            src/libsmf/smf_load.c
            src/libsmf/smf_save.c
            src/libsmf/smf_tempo.c
    '''
    libsmf.export_includes = ['./src/libsmf']
    libsmf.defines      = 'SMF_VERSION="1.2"'
    libsmf.includes     = ['./src']
    libsmf.name         = 'libsmf'
    libsmf.target       = 'smf'
    libsmf.uselib       = 'GLIB'
    libsmf.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')

    lib_source = '''
            src/Control.cpp
            src/ControlList.cpp
            src/ControlSet.cpp
            src/Curve.cpp
            src/Event.cpp
            src/midi_util.cpp
            src/MIDIEvent.cpp
            src/Note.cpp
            src/SMF.cpp
            src/Sequence.cpp
            src/debug.cpp
    '''

    # Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source         = lib_source
    obj.export_includes = ['.']
    obj.includes       = ['.', './src']
    obj.name           = 'libevoral'
    obj.target         = 'evoral'
    obj.uselib         = 'GLIBMM GTHREAD SMF'
    obj.use            = 'libsmf libpbd'
    obj.vnum           = EVORAL_LIB_VERSION
    obj.install_path   = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.defines = ['PACKAGE="libevoral"', 'EVORAL_MIDI_XML=1' ]

    if bld.env['BUILD_TESTS'] and bld.is_defined('HAVE_CPPUNIT'):
        # Static library (for unit test code coverage)
        obj = bld(features = 'cxx cstlib')
        obj.source       = lib_source
        obj.source         = lib_source
        obj.export_includes = ['.']
        obj.includes       = ['.', './src']
        obj.name           = 'libevoral_static'
        obj.target         = 'evoral_static'
        obj.uselib         = 'GLIBMM GTHREAD SMF'
        obj.use            = 'libsmf libpbd'
        obj.vnum           = EVORAL_LIB_VERSION
        obj.install_path   = ''
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = '-lgcov'
            obj.cflags         = [ '-fprofile-arcs',  '-ftest-coverage' ]
            obj.cxxflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]
        obj.defines        = ['PACKAGE="libevoral"', 'EVORAL_MIDI_XML=1' ]

        # Unit tests
        obj              = bld(features = 'cxx cxxprogram')
        obj.source       = '''
                test/SequenceTest.cpp
                test/SMFTest.cpp
                test/RangeTest.cpp
                test/testrunner.cpp
        '''
        obj.includes     = ['.', './src']
        obj.use          = 'libevoral_static'
        obj.uselib       = 'CPPUNIT SNDFILE'
        obj.target       = 'run-tests'
        obj.name         = 'libevoral-tests'
        obj.install_path = ''
        if bld.env['TEST_COVERAGE']:
            obj.linkflags      = '-lgcov'
            obj.cflags         = [ '-fprofile-arcs',  '-ftest-coverage' ]
            obj.cxxflags       = [ '-fprofile-arcs',  '-ftest-coverage' ]

def shutdown():
    autowaf.shutdown()

=== libs/gtkmm2ext/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options
import os

# Version of this package (even if built as a child)
MAJOR = '0'
MINOR = '8'
MICRO = '3'
GTKMM2EXT_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
GTKMM2EXT_LIB_VERSION = '0.8.3'

# Variables for 'waf dist'
APPNAME = 'gtkmm2ext'
VERSION = GTKMM2EXT_VERSION
I18N_PACKAGE = 'gtkmm2ext3'

gtkmm2ext_sources = [
        'actions.cc',
        'application.cc',
        'auto_spin.cc',
        'barcontroller.cc',
        'binding_proxy.cc',
        'bindable_button.cc',
        'bindings.cc',
        'cairocell.cc',
        'cairo_packer.cc',
        'cairo_widget.cc',
        'cell_renderer_color_selector.cc',
        'cell_renderer_pixbuf_multi.cc',
        'cell_renderer_pixbuf_toggle.cc',
        'choice.cc',
        'click_box.cc',
        'debug.cc',
        'dndtreeview.cc',
        'fastmeter.cc',
        'focus_entry.cc',
        'grouped_buttons.cc',
        'gtk_ui.cc',
        'gtkapplication.c',
        'idle_adjustment.cc',
        'keyboard.cc',
        'motionfeedback.cc',
        'persistent_tooltip.cc',
        'prolooks_helpers.c',
        'pixfader.cc',
        'pixscroller.cc',
        'popup.cc',
        'prompter.cc',
        'scroomer.cc',
        'selector.cc',
        'slider_controller.cc',
        'stateful_button.cc',
        'tearoff.cc',
        'textviewer.cc',
        'treeutils.cc',
        'utils.cc',
        'version.cc',
        'visibility_tracker.cc',
        'window_title.cc'
]

# Mandatory variables
top = '.'
out = 'build'

path_prefix = 'libs/gtkmm2ext/'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.build_version_files(path_prefix+'gtkmm2ext/version.h', path_prefix+'version.cc',
                    'libgtkmm2ext', MAJOR, MINOR, MICRO)
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'gtkmm-2.4', uselib_store='GTKMM', atleast_version='2.8')
    autowaf.check_pkg(conf, 'gtk+-2.0', uselib_store='GTK', atleast_version='2.12.1')


def build(bld):
    if bld.is_defined ('INTERNAL_SHARED_LIBS'):
        obj              = bld.shlib(features = 'c cxx cshlib cxxshlib', source=gtkmm2ext_sources)
    else:
        obj              = bld.stlib(features = 'c cxx cstlib cxxstlib', source=gtkmm2ext_sources)
        obj.cxxflags     = [ '-fPIC' ]

    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libgtkmm2ext'
    obj.target       = 'gtkmm2ext'
    obj.uselib       = 'GTKMM GTK GTKOSX OSX GDK'
    obj.use          = [ 'libpbd' ]
    obj.vnum         = GTKMM2EXT_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.defines     = [
                    'PACKAGE="' + I18N_PACKAGE + '"',
                    'LOCALEDIR="' + os.path.join(
                            os.path.normpath(bld.env['DATADIR']), 'locale') + '"']
    if bld.is_defined('GTKOSX'):
        obj.source += ['gtkapplication_quartz.mm']
    else:
        obj.source += ['gtkapplication_x11.c']

    # i18n
    if bld.is_defined('ENABLE_NLS'):
        mo_files = bld.path.ant_glob('po/*.mo')
        for mo in mo_files:
            lang = os.path.basename(mo.srcpath()).replace('.mo', '')
            bld.install_as(os.path.join(bld.env['PREFIX'], 'share', 'locale',
                                        lang, 'LC_MESSAGES', I18N_PACKAGE + '.mo'),
                           mo)

def i18n(bld):
    autowaf.build_i18n(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_pot(bld):
    autowaf.build_i18n_pot(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_po(bld):
    autowaf.build_i18n_po(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def i18n_mo(bld):
    autowaf.build_i18n_mo(bld, top, 'libs/gtkmm2ext', I18N_PACKAGE, gtkmm2ext_sources,
                       'Paul Davis')

def shutdown():
    autowaf.shutdown()

=== libs/libltc/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import TaskGen
import os
import sys

# Version of this package (even if built as a child)
MAJOR = '1'
MINOR = '1'
MICRO = '1'
LIBLTC_VERSION = "%s.%s.%s" % (MAJOR, MINOR, MICRO)

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBLTC_LIB_VERSION = '1.1.1'

# Variables for 'waf dist'
APPNAME = 'libltc'
VERSION = LIBLTC_VERSION
I18N_PACKAGE = 'libltc'

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    if conf.is_defined('USE_EXTERNAL_LIBS'):
        autowaf.check_pkg(conf, 'ltc', uselib_store='LIBLTC', atleast_version=LIBLTC_LIB_VERSION, mandatory=True)
    else:
        conf.load('compiler_c')
        autowaf.configure(conf)

def build(bld):
    if bld.is_defined('USE_EXTERNAL_LIBS'):
        return
    obj = bld(features = 'c cshlib')
    obj.source = '''
              ltc.c
              timecode.c
              encoder.c
              decoder.c
    '''

    obj.export_includes = ['./ltc']
    obj.includes     = ['.']
    obj.name         = 'libltc'
    obj.target       = 'ltc'
    obj.vnum         = LIBLTC_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')
    obj.defines     = ['PACKAGE="' + I18N_PACKAGE + '"']

def shutdown():
    autowaf.shutdown()

=== libs/qm-dsp/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
QM_DSP_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
QM_DSP_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'qm-dsp'
VERSION = QM_DSP_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)

def build(bld):
    # Host Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            dsp/onsets/DetectionFunction.cpp
            dsp/onsets/PeakPicking.cpp
            dsp/phasevocoder/PhaseVocoder.cpp
            dsp/rateconversion/Decimator.cpp
            dsp/rhythm/BeatSpectrum.cpp
            dsp/signalconditioning/DFProcess.cpp
            dsp/signalconditioning/Filter.cpp
            dsp/signalconditioning/FiltFilt.cpp
            dsp/signalconditioning/Framer.cpp
            dsp/transforms/FFT.cpp
            dsp/wavelet/Wavelet.cpp
            maths/Correlation.cpp
            maths/CosineDistance.cpp
            maths/KLDivergence.cpp
            maths/MathUtilities.cpp
            base/Pitch.cpp
    '''
    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libqmdsp'
    obj.target       = 'qmdsp'
    obj.vnum         = QM_DSP_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3')

def shutdown():
    autowaf.shutdown()

=== libs/surfaces/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
from waflib import Options

# Version of this package (even if built as a child)
LIBSURFACES_VERSION = '4.1.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBSURFACES_LIB_VERSION = '4.1.0'

# Variables for 'waf dist'
APPNAME = 'libsurfaces'
VERSION = LIBSURFACES_VERSION

# Mandatory variables
top = '.'
out = 'build'

children = [
        'control_protocol',
        'frontier',
        'generic_midi',
        'mackie',
        'osc',
        'tranzport',
        'wiimote'
]

def options(opt):
    autowaf.set_options(opt)

def sub_config_and_use(conf, name, has_objects = True):
    conf.recurse(name)
    autowaf.set_local_lib(conf, name, has_objects)

def configure(conf):
    autowaf.set_recursive()
    autowaf.configure(conf)

    for i in children:
        sub_config_and_use(conf, i)

    #autowaf.check_pkg(conf, 'libusb-1.0', uselib_store='USB', mandatory=False)
    #if Options.options.tranzport and conf.is_defined('HAVE_USB'):
    #    conf.define('BUILD_TRANZPORT', 1)

    autowaf.check_pkg (conf, 'liblo', mandatory=False, uselib_store="LO", atleast_version="0.24")

    conf.check_cc (header_name='cwiid.h', define_name='HAVE_CWIID_H',mandatory=False)
    if conf.is_defined('HAVE_CWIID_H'):
        conf.check_cc (header_name='bluetooth/bluetooth.h', define_name='HAVE_BLUETOOTH_H',mandatory=False)
        if conf.is_defined('HAVE_BLUETOOTH_H'):
            autowaf.check_pkg(conf, 'cwiid', uselib_store='CWIID', atleast_version='0.6.00',mandatory=False)
            if conf.is_defined ('HAVE_CWIID'):
                conf.define ('BUILD_WIIMOTE', 1)
            else:
                print('You have the cwiid headers needed to compile wiimote support BUT you are missing the pkg-config file for cwiid')
        else:
            print('You are missing the libbluetooth headers needed to compile wiimote support')
    else:
            print('You are missing the cwiid headers needed to compile wiimote support')

def build(bld):
    bld.recurse('control_protocol')
    bld.recurse('generic_midi')
    bld.recurse('mackie')
    if bld.is_defined ('HAVE_LO'):
        bld.recurse('osc')
    if bld.is_defined('BUILD_WIIMOTE'):
        bld.recurse('wiimote')
    if bld.is_defined('BUILD_TRANZPORT'):
        bld.recurse('tranzport')

def shutdown():
    autowaf.shutdown()

=== libs/vamp-plugins/wscript ===
#!/usr/bin/env python
from waflib.extras import autowaf as autowaf
import os

# Version of this package (even if built as a child)
LIBARDOURVAMPPLUGINS_VERSION = '0.0.0'

# Library version (UNIX style major, minor, micro)
# major increment <=> incompatible changes
# minor increment <=> compatible changes (additions)
# micro increment <=> no interface changes
LIBARDOURVAMPPLUGINS_LIB_VERSION = '0.0.0'

# Variables for 'waf dist'
APPNAME = 'libardourvampplugins'
VERSION = LIBARDOURVAMPPLUGINS_VERSION

# Mandatory variables
top = '.'
out = 'build'

def options(opt):
    autowaf.set_options(opt)

def configure(conf):
    conf.load('compiler_cxx')
    autowaf.configure(conf)
    autowaf.check_pkg(conf, 'fftw3f', uselib_store='FFTW3F', mandatory=True)
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO',
                      atleast_version='0.3.2')
    autowaf.check_pkg(conf, 'aubio', uselib_store='AUBIO4',
                      atleast_version='0.4.0', mandatory=False)
    conf.write_config_header('libvampplugins-config.h', remove=False)

def build(bld):
    # Library
    obj = bld(features = 'cxx cxxshlib')
    obj.source = '''
            plugins.cpp
            AmplitudeFollower.cpp
            OnsetDetect.cpp
            PercussionOnsetDetector.cpp
            SpectralCentroid.cpp
            ZeroCrossing.cpp
    '''
    obj.export_includes = ['.']
    obj.includes     = ['.']
    obj.name         = 'libardourvampplugins'
    obj.target       = 'ardourvampplugins'
    obj.uselib       = 'FFTW3F'
    obj.use          = 'libvampplugin libqmdsp'
    if bld.is_defined('HAVE_AUBIO'):
        obj.source += ' Onset.cpp '
        obj.uselib += ' AUBIO '
    obj.vnum         = LIBARDOURVAMPPLUGINS_LIB_VERSION
    obj.install_path = os.path.join(bld.env['LIBDIR'], 'ardour3', 'vamp')

def shutdown():
    autowaf.shutdown()

=== debian/changelog ===
ardour3 (3.5.403~dfsg-3~ubuntu14.04.1) trusty; urgency=medium

  * No-change backport to trusty (LP: #1450992)

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 03 May 2015 15:03:18 -0500

ardour3 (3.5.403~dfsg-3) unstable; urgency=medium

  * Fix MIDI data loss when editing (Closes: #772118)

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Thu, 04 Dec 2014 19:34:45 +0100

ardour3 (3.5.403~dfsg-2) unstable; urgency=high

  * Reupload with waf fixes from 3.5.380~dfsg-2 and -3 

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 03 Oct 2014 14:01:07 +0200

ardour3 (3.5.403~dfsg-1) unstable; urgency=high

  * Imported Upstream version 3.5.403~dfsg
  * Critical bugfix release. All users are recommended to upgrade.
  * Details: https://community.ardour.org/node/8457

 -- Adrian Knoth <adi@drcomp.erfurt.thur.de>  Fri, 03 Oct 2014 13:02:45 +0200

=== debian/control ===
Source: ardour3
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders:
 Adrian Knoth <adi@drcomp.erfurt.thur.de>,
 Jaromír Mikeš <mira.mikes@seznam.cz>
Build-Depends:
 cdbs,
 autotools-dev,
 devscripts,
 debhelper (>= 9~),
 dh-buildinfo,
 gettext,
 intltool,
 libboost-dev (>= 1.49.0),
 libcurl4-gnutls-dev (>= 7.25.0),
 libfftw3-dev (>= 3.3.1),
 libraptor2-dev (>= 2.0.9),
 librdf0-dev (>= 1.0.15),
 liblrdf0-dev (>= 0.4.0),
 libserd-dev (>= 0.18.2~),
 libsord-dev (>= 0.12.0~),
 libsuil-dev (>= 0.6.10~),
 liblilv-dev,
 libsratom-dev (>= 0.4.2~),
 libsigc++-2.0-dev (>= 2.2.10),
 libusb-dev,
 uuid-dev,
 libxml2-dev (>= 2.5.7),
 librasqal3-dev (>= 0.9.28),
 libcwiid-dev,
 libcairomm-1.0-dev (>= 1.10.0),
 libgnomecanvas2-dev (>= 2.30.3),
 libgnomecanvasmm-2.6-dev (>= 2.26.0),
 libgtkmm-2.4-dev (>= 2.24.2),
 libpangomm-1.4-dev (>= 2.28.4),
 ladspa-sdk (>= 1.1-2),
 libasound2-dev (>= 0.9.4),
 libaubio-dev (>= 0.3.2),
 libjack-dev,
 liblo-dev (>= 0.26~),
 libsamplerate0-dev (>= 0.1.8),
 libsndfile1-dev (>= 1.0.25),
 libsoundtouch-dev (>= 1.5.0),
 lv2-dev (>= 1.2.0),
 vamp-plugin-sdk (>=2.1),
 python-setuptools,
 python-isodate,
 libpcre3-dev,
 python-rdflib
Standards-Version: 3.9.6
Homepage: http://www.ardour.org/
Vcs-Git: git://anonscm.debian.org/pkg-multimedia/ardour3.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-multimedia/ardour3.git

Package: ardour3
Architecture: any
Depends:
 ${cdbs:Depends},
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends}
Recommends:
 ${cdbs:Recommends}
Suggests:
 ${shlibs:Suggests}
Conflicts:
 ${cdbs:Conflicts}
Replaces:
 ${cdbs:Replaces}
Description: digital audio workstation (graphical gtk2 interface)
 Ardour is a multichannel hard disk recorder (HDR) and digital audio
 workstation (DAW).  It can be used to control, record, edit and run
 complex audio setups.
 .
 Ardour supports pro-audio interfaces
 through the ALSA project, which provides high quality, well designed
 device drivers and API's for audio I/O under Linux. Any interface
 supported by ALSA can be used with Ardour. This includes the
 all-digital 26 channel RME Hammerfall, the Midiman Delta 1010 and many
 others.
 .
 Ardour has support for 24 bit samples
 using floating point internally, non-linear editing with unlimited undo,
 a user-configurable mixer, MTC master/slave capabilities, MIDI hardware
 control surface compatibility.
 .
 It supports MIDI
 Machine Control, and so can be controlled from any MMC controller and
 many modern digital mixers.
 .
 Ardour contains a
 powerful multitrack audio editor/arranger that is completely
 non-destructive and capable of all standard non-linear editing
 operations (insert, replace, delete, move, trim, select,
 cut/copy/paste). The editor has unlimited undo/redo capabilities and can
 save independent "versions" of a track or an entire piece
 .
 Ardour's editor supports the community-developed LADSPA
 plugin standard.  Arbitrary chains of plugins can be attached to any
 portion of a track.  Every mixer strip can have any number of inputs
 and outputs, not just mono, stereo or 5.1.  An N-way panner is
 included, with support for various panning models.  Pre- and post-fader
 sends exist, each with their own gain and pan controls.  Every mixer
 strip acts as its own bus, and thus the bus count in Ardour is
 unlimited.  You can submix any number of strips into another
 strip.
 .
 Ardour's channel capacity is limited only
 by the number on your audio interface and the ability of your disk
 subsystem to stream the data back and forth.
 .
 JACK
 (the JACK Audio Connection Kit) is used for all audio I/O, permitting
 data to be exchanged in perfect samplesync with other applications
 and/or hardware audio interfaces.
 .
 Ardour is
 sample rate and size neutral - any hardware formats from 8 to 32 bits,
 and rates from 8kHz to 192kHz.  Internal processing in 32/64 bit IEEE
 floating point format.
 .
 Further information can be
 found at <http://ardour.org/>.

=== debian/rules ===
#!/usr/bin/make -f
#
# Robert Jordens <jordens@debian.org>
#
# This software may be used and distributed according to the terms
# of the GNU General Public License, incorporated herein by reference.

-include /usr/share/cdbs/1/rules/upstream-tarball.mk
-include /usr/share/cdbs/1/rules/utils.mk
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_CLEAN_EXCLUDE=debian/tmp
DEB_DESTDIR = $(CURDIR)/debian/tmp/

# ignore oddly packaged bzip2 archive to not upset dpkg
DEB_COPYRIGHT_CHECK_IGNORE_REGEX = ^\./waf|\./debian/(changelog|copyright(|_hints|_newhints))$

DIST_TARGET = none
ifneq (,$(findstring i386,$(DEB_BUILD_ARCH)))
	DIST_TARGET = i686
endif
ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
	DIST_TARGET = x86_64
endif

LD_LIBRARY_PATH += :$(DEB_DESTDIR)/usr/lib/ardour3/

waf-configure-options = --lv2 \
	--lxvst \
	--freedesktop \
	--configdir=/etc/ \
	--noconfirm \
	--prefix=/usr/ \
	--no-phone-home \
	--dist-target=$(DIST_TARGET) \
	--optimize \


DEB_MAKE_PARALLEL = -j$(if $(DEB_PARALLEL_JOBS),$(DEB_PARALLEL_JOBS),1)
DEB_MAKE_EXTRA_ARGS = -v --destdir=$(CURDIR)/debian/tmp $(DEB_MAKE_PARALLEL)
DEB_MAKE_BUILD_TARGET = build i18n_mo
DEB_MAKE_ENVVARS = CFLAGS="$(or $(CFLAGS_$(cdbs_curpkg)),$(CFLAGS))" CXXFLAGS="$(or $(CXXFLAGS_$(cdbs_curpkg)),$(CXXFLAGS))" CPPFLAGS="$(or $(CPPFLAGS_$(cdbs_curpkg)),$(CPPFLAGS))" LDFLAGS="$(or $(LDFLAGS_$(cdbs_curpkg)),$(LDFLAGS))"
DEB_MAKE_INVOKE = $(DEB_MAKE_ENVVARS) $(CURDIR)/waf-light $(DEB_MAKE_EXTRA_ARGS)
DEB_MAKE_INSTALL_TARGET = install


clean::
	rm -f autowaf.pyc
	rm -f .lock-wscript .lock-waf_linux2_build
	find waflib -name "*.pyc" -delete || true
	find . -name "*.mo" -delete || true
	rm -rf build
	rm -f \
		gtk2_ardour/version.cc\
		gtk2_ardour/version.h\
		libs/ardour/ardour/version.h\
		libs/ardour/config_text.cc\
		libs/ardour/svn_revision.cc\
		libs/ardour/version.cc\
		libs/gtkmm2ext/gtkmm2ext/version.h\
		libs/gtkmm2ext/version.cc\
		libs/midi++2/midi++/version.h\
		libs/midi++2/version.cc\
		libs/pbd/pbd/version.h\
		libs/pbd/version.cc
	rm -rf debian/tmp


common-configure-arch common-configure-indep:: common-configure-impl
common-configure-impl:: libs/ardour/revision.cc debian/stamp-waf-configure


libs/ardour/revision.cc:
	echo '#include "ardour/revision.h"' > $@
	echo "namespace ARDOUR { const char* revision = \"${DEB_VERSION}\"; }" >> $@

debian/stamp-waf-configure:
	chmod +x ./waf-light
	$(DEB_MAKE_INVOKE) configure $(waf-configure-options)
	touch $@
clean::
	rm -f debian/stamp-waf-configure
	rm -f libs/ardour/revision.cc

# Needed at build time
# (separated in build tools, core, Glib/GTK and audio dependencies)
CDBS_BUILD_DEPENDS += , gettext,\
					  intltool
CDBS_BUILD_DEPENDS += , libboost-dev (>= 1.49.0),\
					  libcurl4-gnutls-dev (>= 7.25.0),\
					  libfftw3-dev (>= 3.3.1),\
					  libraptor2-dev (>= 2.0.9),\
					  librdf0-dev (>= 1.0.15),\
					  liblrdf0-dev (>= 0.4.0), \
					  libserd-dev (>= 0.18.2~),\
					  libsord-dev (>= 0.12.0~),\
					  libsuil-dev (>= 0.6.10~),\
					  liblilv-dev,\
					  libsratom-dev (>= 0.4.2~),\
					  libsigc++-2.0-dev (>= 2.2.10),\
					  libusb-dev,\
					  uuid-dev,\
					  libxml2-dev (>= 2.5.7),\
					  librasqal3-dev (>= 0.9.28),\
					  libcwiid-dev
CDBS_BUILD_DEPENDS += , libcairomm-1.0-dev (>= 1.10.0),\
					  libgnomecanvas2-dev (>= 2.30.3),\
					  libgnomecanvasmm-2.6-dev (>= 2.26.0),\
					  libgtkmm-2.4-dev (>= 2.24.2),\
					  libpangomm-1.4-dev (>= 2.28.4)
CDBS_BUILD_DEPENDS += , ladspa-sdk (>= 1.1-2),\
					  libasound2-dev (>= 0.9.4),\
					  libaubio-dev (>= 0.3.2),\
					  libjack-dev,\
					  liblo-dev (>= 0.26~),\
					  libsamplerate0-dev (>= 0.1.8),\
					  libsndfile1-dev (>= 1.0.25),\
					  libsoundtouch-dev (>= 1.5.0),\
					  lv2-dev (>= 1.2.0),\
					  vamp-plugin-sdk (>=2.1)
CDBS_BUILD_DEPENDS += , python-setuptools,\
					  python-isodate,\
					  libpcre3-dev,\
					  python-rdflib


# Needed always/often/sometimes at runtime
CDBS_DEPENDS_ALL = jackd
CDBS_RECOMMENDS_ALL = iceweasel | www-browser
CDBS_SUGGESTS_ALL = jamin, qjackctl

# Ensure only one variant is installed at a time
CDBS_PROVIDES_ardour-altivec = ardour
CDBS_PROVIDES_ardour-i686 = ardour

# Quirk for derivatives using different packaging name
ifeq (Ubuntu,$(shell dpkg-vendor --query Vendor))
CDBS_RECOMMENDS_ALL = firefox | www-browser
endif
